#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int main()
{
	/*
	center_count : count of center postion
	target_post  : post number selected by post_select()
		"post number" means seaquencial number of posts found in post_search()
	target_code  : IRS code of the post to get now
		This variable is defined as gloabl varialble.
	*/
	int center_count=0;
	int center_corr_count=0;
	int target_post;
	int ret;
	int search_retry, search_result=-1;

	post.got_number=0;

	printf("Initialize\n");
	ret=initialize();

	printf("Move to center\n");
	lqr_straight(1450,6000);
	//lqr_straight(1000,5000);
	//exit(0);

POST_SH:

	printf("POST_NUM= %d  post.got_number= %d\n",POST_NUM, post.got_number);
	if(post.got_number==POST_NUM) goto END;

	center_count++;
	center_corr_count++;

        usleep(500000);

        pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);


	printf("Post search 1st Try\n");
//	post_search(center_count);

	if(center_count==1){
		printf("Searched post number =%d\n",post.number);
		while(post.number!=POST_NUM){
        		usleep(500000);
			post_search(center_count);
			printf("Searched post number =%d\n",post.number);
		}
	}

//	if(center_count>1){
	if(center_corr_count>2){
		printf("Searched post number =%d\n",post_tmp.number);
		search_retry=0;
		search_result=0;
		while(post_tmp.number!=POST_NUM){
        		usleep(500000);
			if(search_retry>=2){
				search_result=-1;
				break;
			}
			post_search(center_count);
			printf("Searched post number =%d\n",post_tmp.number);
			search_retry++;
		}
	}
        usleep(500000);


//	if(center_count>1 && search_result==0) {
	if(center_corr_count>2 && search_result==0) {
		center_corr_count=0; 
		printf("Move to correct center position\n");
		//printf("dis1=%d dis2=%d ang1=%d ang2=%d\n",post.dis[0],post.dis[1],post.ang[0],post.ang[1]);
		//printf("dis1_=%d dis2_=%d ang1_=%d ang2_=%d\n",post_tmp.dis[0],post_tmp.dis[1],post_tmp.ang[0],post_tmp.ang[1]);
		correct_center();
	}

	pthread_cancel(uss_task);
        pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);

        usleep(500000);
	target_post = post_select(center_count);
	printf("Next post is %d\n",target_post);

	printf("Approach target_post\n");
	post_approach(target_post);

	target_code=post.got_code+1;

	printf("Post get start\n");
	post_get(target_post);

	pthread_cancel(uss_task2);

	printf("Move center\n");
	move_center(target_post);

	goto POST_SH;

END:

	usleep(1000000);
	pwm_both_data(0,0);
	usleep(400000);
	pwm_enco_stop();
	usleep(400000);
	printf("All posts have been got\n");

	// close all device file 
        close(fd0);
        close(fd1);
        close(fd2);
        close(fd3);
        close(fd4);
        close(fd5);
        close(fd6);
        close(fd7);
        close(ctl);
        return 0;
}

