/*
	Functions used in control program

	post_select:
		Select next post to which MIRS approah 
	irs_code_get: 
		Get IRS code
	uss_get:
		Get USS data (one shot task)
	correct_distance:
		Correct distance between MIRS and POST before approach 
		the target post.
	correct_direction1:
		Correct direction before approach the target post.
	correct_direction2:
		Correct direction after approach the target post.
	move_center:
		Move to center postion after post_get mode
	lqr_rotate:
		Macro of rotaion in LQR mode;
	lqr_straght:
		Macro of straight movement in LQR mode;
	lqr_circle:
		Macro of going around a post in LQR mode;
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include <math.h>

int post_select(){

	int i,j;
	//int next_post_code;
	//int dis_min=3000; 
	
	for(j=0;j<4;j++){	

	  for(i=0;i<post.number;i++){
	    if(post.code[i]==target_code){return i;}
	  }
	  
	  target_code++;
	}

	for(i=0;i<post.number;i++){
	  if(post.code[i]==0){return i;}
	}

	return 4;
}

int nearest_post(){

  int dis_min=3000,i,next_post_num=-1;

  for(i=0;i<post.number;i++){
    if(post.dis[i]<dis_min){
      dis_min=post.dis[i];
      next_post_num=i;
    }
       }
       return next_post_num;
  }

int irs_code_get(int dumy){

	int irs_select;
	int irs_get_code=0;
	char code_char='0';
	irs_select = dumy;

	fd6=open("/dev/irs_code",O_RDWR);
	write(fd6,&irs_select,sizeof(int));
        usleep(10000);
	read(fd6,&code_char,sizeof(char));
	close(fd6);
	fd6=open("/dev/irs_code",O_RDWR);
        usleep(100000);
	read(fd6,&code_char,sizeof(char));

	if(code_char=='1') {irs_get_code=1; goto NEXT;}
	if(code_char=='2') {irs_get_code=2; goto NEXT;}
	if(code_char=='3') {irs_get_code=3; goto NEXT;}
	if(code_char=='4') {irs_get_code=4; goto NEXT;}
	if(code_char=='5') {irs_get_code=5; goto NEXT;}
	if(code_char=='6') {irs_get_code=6; goto NEXT;}
  NEXT:
        usleep(100000);
	close(fd6);

	printf("irs_get_code=%d\n",irs_get_code);

	return irs_get_code;
}

int uss_get(int uss_no){

        uss_msg.command=1; /* 1 Shot Task */
        uss_msg.number = uss_no;
        write(ctl, &uss_msg, sizeof(uss_msg));

        usleep(30000);
        printf("uss%d=%d\n",uss_no,uss_data);
        return uss_data;
}

int correct_direction1(int target_post){
	int uss1,uss2,angle;
	int cor_ang=0,ac,acc;
	int rot_time;
	int max=2500;
	angle=0;
	ac=-1;acc=1;
	//maxdif=35;

	while(1){
	  uss1=0;uss2=0;
           while(uss1<=0 || uss2<=0){
		uss1=uss_get(1);
		usleep(20000);
		uss2=uss_get(2);
		usleep(20000);
                }
		if(uss1>max && uss2>max){
			cor_ang=acc*ac*2-cor_ang;
			rot_time=cor_ang*20;
			lqr_rotate(cor_ang,rot_time); 
		        usleep(200000);
			//if(abs(cor_ang)>=20)angle+=cor_ang/2;
			ac*=-1;
			acc++;
			//if(abs(cor_ang)>20){cor_ang=0;}
			goto NSS1;
		}		
		if( uss1>max){
		  cor_ang=0;acc=1;
		  if(uss2<=600){lqr_rotate(-20,400);usleep(200000);angle=angle-10;}
		  else{lqr_straight(100,500);}
			goto NSS1;
		}
		if( uss2>max){
		  cor_ang=0;acc=1;
		  if(uss1<=600){lqr_rotate(20,400);usleep(200000);angle=angle+10;}
	          else{lqr_straight(100,500);}
			goto NSS1;
		}
		    if(uss1<max && uss2<max){goto END;}   
		    //if(uss1-USS12_DIFF>uss2){i=-1*i;lqr_rotate(i,i*20);usleep(200000);angle=angle+i;}
		    //else{lqr_rotate(i,i*20);usleep(200000);angle=angle+i;}
		cor_ang=0;acc=1;      
		NSS1:
		usleep(50000);
	}
	END:
        mirs_angle+=(double)angle;
	//printf("angle=%d",angle);
	//printf("mirs_angle=%lf",mirs_angle);
	//printf("uss1=%d uss2=%d\n",uss1,uss2);
	
	return (uss1+uss2)/2;
	//if(uss1>uss2){return uss2;}
	//else{return uss1;}
}

int correct_direction2(){
	int uss1,uss2,angle,i;
	int cor_ang=0,ac,acc;
	int rot_time;
	angle=0;
	ac=-1;acc=1;

	while(1){
		usleep(200000);
		uss1=0; uss2=0;
		uss1=uss_get(1);
		usleep(20000);
		uss2=uss_get(2);
		usleep(20000);

		if( uss1>400 && uss2>400 ){
			cor_ang=acc*ac*2-cor_ang;
			rot_time=cor_ang*20;
			lqr_rotate(cor_ang,rot_time);
			usleep(20000);
			//if(abs(cor_ang)>=20)angle+=cor_ang/2;
			ac*=-1;
			acc++;
			goto NSS1;
		}
		/*
		if( uss1>400 ){
		  cor_ang=0;acc=1;
			lqr_rotate(-10,150); usleep(20000); angle=angle-10;
			goto NSS1;
		}
		if( uss2>400 ){
		  cor_ang=0;acc=1;
			lqr_rotate(10,150); usleep(20000);angle=angle+10;
			goto NSS1;
			}
		*/for(i=20;i>15;i--){
		    if(abs(uss1-uss2-USS12_DIFF)<=20){ goto END;}
		    if(uss1-USS12_DIFF>uss2){i=-1*i;lqr_rotate(i,i*20);usleep(200000);if(i<=-20)angle+=i/2;}
		    else{lqr_rotate(i,i*20);usleep(200000);if(i>=20)angle+=i/2;}
		uss1=0; uss2=0;
		uss1=uss_get(1);
		usleep(20000);
		uss2=uss_get(2);
		usleep(20000);
		}
		    cor_ang=0;acc=1;
		NSS1:
		usleep(50000);
	}
	END:
	mirs_angle+=(double)angle;
	//printf("angle=%d",angle);
	//printf("mirs_angle=%lf",mirs_angle);
	
	/*
	printf("uss1=%d uss2=%d\n",uss1,uss2);
	diff=uss1-uss2-USS12_DIFF-265;
	if(abs(diff)>50){
	  lqr_straight(diff,diff*10);
	}
*/
return 0;
}

int correct_ir(){
  int irs_front=0;
	int cor_ang=0,ac,acc;
	int rot_time;
	 ac=-1;acc=1;

	while(irs[irs_front]!='1'){		
			cor_ang=acc*ac*2-cor_ang;
			rot_time=cor_ang*20;
			lqr_rotate(cor_ang,rot_time); 
			mirs_angle+=(double)cor_ang;
			ac*=-1;
			acc++;

			if(abs(cor_ang)>20){break;}
	}
return 0; 
}

int correct_distance(){

	int uss1,uss2,diff;
                        uss1=uss_get(1);
                        usleep(20000);
			uss2=uss_get(2);
			usleep(20000);
		
		diff =(uss1 + uss2)/2 - (360-100-117);
 
		while(abs(diff)>10){
			uss1=uss_get(1);
                        usleep(20000);
			uss2=uss_get(2);
			usleep(20000);
		
			diff =(uss1 + uss2)/2 - (360-100-117); 
	     
			lqr_straight(diff,diff*10);
		
				}
	return 0;
}

int lqr_rotate(int ang,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_rotate(ang,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}

int lqr_straight(int dis,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_straight(dis,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}

int lqr_circle(int radious,int ang,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_circle(radious,ang,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}
