/*
	Function: post_get
	MIRS acts as follows in this function.
	1. Turn to 90 degree
	2. Go arround post with detecting IRS signal
	3. If IRS code is target code, MIRS gets the post.
	4. MIRS retuns to the start position of 1.
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"


int post_get(int target_post,int g){

        int irs_front=0;
        int irs_left=1;
        int rot_cur;
        int retry_num;

        int dis2;
	int circle_radious2=circle_radious;
	/*
	Variable "circle_radious" defined in control.h is a radious groing arround 
	the post.  cirlce_radious2 is used in this function, whose default value 
	equals that of circle_radious. 
	*/

        int fwd_dis=0,back_dis;
	int rot_time;
	int ir_code;
	int ir_left;
	int code_check=0;
	int ts_on;
	//int get_code;
        //int uss1,uss2;

	ts_on=0;
	retry_num=0;
	ir_code=0;
	ir_left=0;
	if(g!=0){
	lqr_rotate(-90, 1800);
	mirs_angle+=-90.0;
	}
	//AGAIN:
	// Start encoder task 
	pwm_enco_start(10);
	usleep(20000);

	// If you redefine cirlce_radious based on current USS value, 
	// remove commnet-out in next line.
	//circle_radious2=(uss_get(3)-15)+dist_ct+post_diameter/2+30;
	pwm_lqr_circle(circle_radious2, 360, 15000);

	count.br=0;

	while(1){

		if(irs[irs_left]=='1') ir_left=1;
		ir_code=irs_code_get(irs_left);
		if(ir_code!=0 || ir_left==1){
                	rot_cur=90/pi*(alw+arw)/circle_radious2;
                        pwm_both_data(0,0);
                        usleep(40000);
			pwm_enco_stop();
                        usleep(100000);

	while(code_check<5){
	  if(ir_code!=0){post.code[target_post]=ir_code;break;}
		ir_code=irs_code_get(1);
		usleep(50000);
		code_check++;
	}
	
		 aa-=ir_code;
		 code_count++;
		 if(code_count == POST_NUM-1){
		   post.code[target_post+1]=aa;
		   }
		if(ir_code==target_code){goto NEXT;}
			//lqr_circle(circle_radious2, 10, 1000);
			//rot_cur+=10;
		/*			
			printf("rot_cur=%d\n",rot_cur);
			scanf("%d",&a);
                 */
                        break;
                }
                if(count.br==1) {
                        pwm_both_data(0,0);
                        usleep(40000);
			pwm_enco_stop();
                        usleep(100000);
			printf("irs was not detected.\n");
			//i++;
			//if(i==1)goto AGAIN;
                        goto BY2;
                }
        }

	goto BY;
NEXT:
        lqr_rotate(90,1800);
    RETRY:
	retry_num++;

	//dis2=(uss1+uss2)/2;
	dis2=450+40*retry_num;

       	pwm_enco_start(20);
	usleep(10000);
        pwm_lqr_straight(dis2,dis2*10);
	count.br=0;

	while(1){
		if(count.br==1) break;
		if(ts[0]=='1' || ts[1]=='1' || ts[3]=='1') {
			fwd_dis=(alw+arw)/2;
			ts_on=1;
			printf("push post !  fwd_dis=%d\n",fwd_dis);
			break;
		}
		usleep(100000);
	}
        pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	usleep(20000);
	printf("post pushed\n");
	printf("fwd_dis=%d\n",fwd_dis);
	sleep(1);

	if(fwd_dis!=0){
		back_dis=-fwd_dis;
	}else{
		back_dis=-dis2;
	}
	printf("away from post   back_dis=%d\n",back_dis);
	lqr_straight(back_dis,back_dis*10);
	usleep(500000);

	if(irs[irs_front]=='0' && ts_on==1){
		post.got_code=target_code;
		post.got_number++;
		target_code++;
		printf("Post get !!! got_code=%d",post.got_code);
		//goto BY;
	}else if(retry_num<3){
	  // correct_ir();
		goto RETRY;
	}
	lqr_rotate(-90,1800);
 BY:
	if(rot_cur<180){
	  rot_time=rot_cur*42;
	  lqr_circle(390,-rot_cur,rot_time);
	}else{
	  rot_time=(360-rot_cur)*42;
	  lqr_circle(circle_radious2,360-rot_cur,rot_time);
	}
	BY2:
	return 0;
}

